/* eslint-disable */ 
export default {
  isIdCard(value) {
    return /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/.test(value)
  },
  isEmail(value) {
    return /^([a-z0-9_.-]+)@([\da-z.-]+)\.([a-z.]{2,6})$/.test(value)
  },
  isCH(value) {
    return /[^\u4e00-\u9fa5]/.test(value)
  },
  isPhone(value) {
    return /^1[0-9]{10}$/.test(value)
  },
  isBankCard(value) {
    if (!value) return false
    let lastNum = value.substr(value.length - 1, 1) // 取出最后一位（与luhn进行比较）
    let first15Num = value.substr(0, value.length - 1) // 前15或18位
    let newArr = new Array()
    for (let i = first15Num.length - 1; i > -1; i--) {
      // 前15或18位倒序存进数组
      newArr.push(first15Num.substr(i, 1))
    }
    let arrJiShu = new Array() // 奇数位*2的积 <9
    let arrJiShu2 = new Array() // 奇数位*2的积 >9
    let arrOuShu = new Array() // 偶数位数组
    for (let j = 0; j < newArr.length; j++) {
      if ((j + 1) % 2 === 1) {
        // 奇数位
        if (parseInt(newArr[j]) * 2 < 9) {
          arrJiShu.push(parseInt(newArr[j]) * 2)
        } else {
          arrJiShu2.push(parseInt(newArr[j]) * 2)
        }
      } else {
        arrOuShu.push(newArr[j])
      }
    }

    let jishu_child1 = new Array() // 奇数位*2 >9 的分割之后的数组个位数
    let jishu_child2 = new Array() // 奇数位*2 >9 的分割之后的数组十位数
    for (let h = 0; h < arrJiShu2.length; h++) {
      jishu_child1.push(parseInt(arrJiShu2[h]) % 10)
      jishu_child2.push(parseInt(arrJiShu2[h]) / 10)
    }

    let sumJiShu = 0 // 奇数位*2 < 9 的数组之和
    let sumOuShu = 0 // 偶数位数组之和
    let sumJiShuChild1 = 0 // 奇数位*2 >9 的分割之后的数组个位数之和
    let sumJiShuChild2 = 0 // 奇数位*2 >9 的分割之后的数组十位数之和
    let sumTotal = 0
    for (let m = 0; m < arrJiShu.length; m++) {
      sumJiShu = sumJiShu + parseInt(arrJiShu[m])
    }

    for (let n = 0; n < arrOuShu.length; n++) {
      sumOuShu = sumOuShu + parseInt(arrOuShu[n])
    }

    for (let p = 0; p < jishu_child1.length; p++) {
      sumJiShuChild1 = sumJiShuChild1 + parseInt(jishu_child1[p])
      sumJiShuChild2 = sumJiShuChild2 + parseInt(jishu_child2[p])
    }
    // 计算总和
    sumTotal =
      parseInt(sumJiShu) +
      parseInt(sumOuShu) +
      parseInt(sumJiShuChild1) +
      parseInt(sumJiShuChild2)

    // 计算luhn值
    let k = parseInt(sumTotal) % 10 === 0 ? 10 : parseInt(sumTotal) % 10
    let luhn = 10 - k

    if (lastNum === luhn) {
      return true
    } else {
      return false
    }
  },
  isTradePwd (value) {
    return /^[0-9]{6}$/.test(value)
  }
}